diff --git a/spring-boot-project/spring-boot-autoconfigure/src/main/java/org/springframework/boot/autoconfigure/data/redis/RedisConnectionConfiguration.java b/spring-boot-project/spring-boot-autoconfigure/src/main/java/org/springframework/boot/autoconfigure/data/redis/RedisConnectionConfiguration.java
index 2435e2bb032..e727688103d 100644
--- a/spring-boot-project/spring-boot-autoconfigure/src/main/java/org/springframework/boot/autoconfigure/data/redis/RedisConnectionConfiguration.java
+++ b/spring-boot-project/spring-boot-autoconfigure/src/main/java/org/springframework/boot/autoconfigure/data/redis/RedisConnectionConfiguration.java
@@ -111,8 +111,7 @@ protected final RedisClusterConfiguration getClusterConfiguration() {
 
 	private List<RedisNode> createSentinels(RedisProperties.Sentinel sentinel) {
 		List<RedisNode> nodes = new ArrayList<>();
-		for (String node : StringUtils
-				.commaDelimitedListToStringArray(sentinel.getNodes())) {
+		for (String node : sentinel.getNodes()) {
 			try {
 				String[] parts = StringUtils.split(node, ":");
 				Assert.state(parts.length == 2, "Must be defined as 'host:port'");
diff --git a/spring-boot-project/spring-boot-autoconfigure/src/main/java/org/springframework/boot/autoconfigure/data/redis/RedisProperties.java b/spring-boot-project/spring-boot-autoconfigure/src/main/java/org/springframework/boot/autoconfigure/data/redis/RedisProperties.java
index b84279353ad..bf56d058a5b 100644
--- a/spring-boot-project/spring-boot-autoconfigure/src/main/java/org/springframework/boot/autoconfigure/data/redis/RedisProperties.java
+++ b/spring-boot-project/spring-boot-autoconfigure/src/main/java/org/springframework/boot/autoconfigure/data/redis/RedisProperties.java
@@ -266,9 +266,9 @@ public void setMaxRedirects(Integer maxRedirects) {
 		private String master;
 
 		/**
-		 * Comma-separated list of host:port pairs.
+		 * Nodes as host:port pairs.
 		 */
-		private String nodes;
+		private String[] nodes;
 
 		public String getMaster() {
 			return this.master;
@@ -278,11 +278,11 @@ public void setMaster(String master) {
 			this.master = master;
 		}
 
-		public String getNodes() {
+		public String[] getNodes() {
 			return this.nodes;
 		}
 
-		public void setNodes(String nodes) {
+		public void setNodes(String[] nodes) {
 			this.nodes = nodes;
 		}
 
diff --git a/spring-boot-project/spring-boot-autoconfigure/src/test/java/org/springframework/boot/autoconfigure/data/redis/RedisAutoConfigurationTests.java b/spring-boot-project/spring-boot-autoconfigure/src/test/java/org/springframework/boot/autoconfigure/data/redis/RedisAutoConfigurationTests.java
index 0c34e276a71..2635e78c85b 100644
--- a/spring-boot-project/spring-boot-autoconfigure/src/test/java/org/springframework/boot/autoconfigure/data/redis/RedisAutoConfigurationTests.java
+++ b/spring-boot-project/spring-boot-autoconfigure/src/test/java/org/springframework/boot/autoconfigure/data/redis/RedisAutoConfigurationTests.java
@@ -18,6 +18,8 @@
 
 import java.util.Arrays;
 import java.util.List;
+import java.util.Set;
+import java.util.stream.Collectors;
 
 import org.junit.After;
 import org.junit.Test;
@@ -26,6 +28,7 @@
 import org.springframework.context.annotation.AnnotationConfigApplicationContext;
 import org.springframework.context.annotation.Bean;
 import org.springframework.context.annotation.Configuration;
+import org.springframework.data.redis.connection.RedisNode;
 import org.springframework.data.redis.connection.lettuce.LettuceClientConfiguration.LettuceClientConfigurationBuilder;
 import org.springframework.data.redis.connection.lettuce.LettuceConnectionFactory;
 import org.springframework.data.redis.connection.lettuce.LettucePoolingClientConfiguration;
@@ -153,12 +156,15 @@ public void testRedisConfigurationWithSentinel() throws Exception {
 
 	@Test
 	public void testRedisConfigurationWithSentinelAndPassword() throws Exception {
-		List<String> sentinels = Arrays.asList("127.0.0.1:26379", "127.0.0.1:26380");
 		load("spring.redis.password=password", "spring.redis.sentinel.master:mymaster",
-				"spring.redis.sentinel.nodes:"
-						+ StringUtils.collectionToCommaDelimitedString(sentinels));
-		assertThat(this.context.getBean(LettuceConnectionFactory.class).getPassword())
-				.isEqualTo("password");
+				"spring.redis.sentinel.nodes:127.0.0.1:26379,  127.0.0.1:26380");
+		LettuceConnectionFactory connectionFactory = this.context
+				.getBean(LettuceConnectionFactory.class);
+		assertThat(connectionFactory.getPassword()).isEqualTo("password");
+		Set<RedisNode> sentinels = connectionFactory.getSentinelConfiguration()
+				.getSentinels();
+		assertThat(sentinels.stream().map(Object::toString).collect(Collectors.toSet()))
+				.contains("127.0.0.1:26379", "127.0.0.1:26380");
 	}
 
 	@Test
diff --git a/spring-boot-project/spring-boot/src/test/java/org/springframework/boot/context/properties/bind/ArrayBinderTests.java b/spring-boot-project/spring-boot/src/test/java/org/springframework/boot/context/properties/bind/ArrayBinderTests.java
index 960001c2df9..d0af1601ed3 100644
--- a/spring-boot-project/spring-boot/src/test/java/org/springframework/boot/context/properties/bind/ArrayBinderTests.java
+++ b/spring-boot-project/spring-boot/src/test/java/org/springframework/boot/context/properties/bind/ArrayBinderTests.java
@@ -270,4 +270,13 @@ public void bindToArrayWhenEmptyStringShouldReturnEmptyArray() throws Exception
 		assertThat(result).isNotNull().isEmpty();
 	}
 
+	@Test
+	public void bindToArrayWhenHasSpacesShouldTrim() throws Exception {
+		MockConfigurationPropertySource source = new MockConfigurationPropertySource();
+		source.put("foo", "1,  2,3");
+		this.sources.add(source);
+		String[] result = this.binder.bind("foo", Bindable.of(String[].class)).get();
+		assertThat(result).containsExactly("1", "2", "3");
+	}
+
 }
